// Generated by CoffeeScript 1.10.0
(function() {
  var _, webdriverDefaultConf;

  webdriverDefaultConf = require('./webdriver.default');

  _ = require('lodash');

  module.exports = function(customConfig) {
    var base, base1, base2, config, e, error, hasCoffee, ref;
    config = _.defaults({}, customConfig, webdriverDefaultConf, {
      specs: ['./test/e2e/**/*.js', './test/e2e/**/*.coffee'],
      exclude: ['./test/e2e/**/_*.js', './test/e2e/**/_*.coffee'],
      capabilities: {}
    });
    if (config.server == null) {
      config.server = {};
    }
    _.defaultsDeep(config.server, {
      startCommand: 'npm start',
      env: {
        MONGO_URL: 'mongodb://localhost:27017/test',
        PORT: ((ref = config.baseUrl.match(/:(\d+)[^:]/)) != null ? ref[1] : void 0) || 80
      },
      waitServer: {
        timeout: 10 * 1000,
        interval: 800,
        print: true,
        req: config.baseUrl
      }
    });
    hasCoffee = true;
    try {
      require.resolve('coffee-script');
    } catch (error) {
      e = error;
      hasCoffee = false;
    }
    _.defaults(config, {
      framework: 'mocha',
      reporter: 'spec',
      mochaOpts: {
        ui: 'bdd',
        compilers: hasCoffee ? ['coffee:coffee-script/register'] : void 0,
        timeout: config.waitforTimeout,
        bail: true
      }
    });
    if (process.env.TRAVIS) {
      if ((base = config.desiredCapabilities).chromeOptions == null) {
        base.chromeOptions = {};
      }
      if ((base1 = config.desiredCapabilities.chromeOptions).args == null) {
        base1.args = ['no-sandbox'];
      }
      if ((base2 = config.desiredCapabilities.chromeOptions).binary == null) {
        base2.binary = __dirname + '/chrome-linux/chrome';
      }
    }
    config.before = require('./lib/before')(config, config.before);
    config.after = (function(customAfter) {
      return function(failures, pid) {
        var Bluebird;
        Bluebird = require('bluebird');
        return Bluebird.mapSeries(Object.keys(config.browsers), function(groupName) {
          return global[groupName].end();
        }).then(function() {
          return typeof customAfter === "function" ? customAfter(failures, pid) : void 0;
        });
      };
    })(config.after);
    return config;
  };

}).call(this);
