// Generated by CoffeeScript 1.10.0
(function() {
  var Bluebird, _, addCustomCommands, chai, chaiAsPromised, natural, nounInflector, shell, waitServer, webdriverio;

  Bluebird = require('bluebird');

  natural = require('natural');

  nounInflector = new natural.NounInflector();

  shell = require('shelljs');

  _ = require('lodash');

  chai = require('chai');

  chaiAsPromised = require('chai-as-promised');

  webdriverio = require('webdriverio');

  global.X = require('./xpath');

  addCustomCommands = require('./commands');

  waitServer = require('./waitServer');

  module.exports = function(webdriverConf, customBefore) {
    return function() {
      var groupName, ref, ref1, value;
      chai.Should();
      chai.use(chaiAsPromised);
      chaiAsPromised.transferPromiseness = browser.transferPromiseness;
      ref = webdriverConf.browsers;
      for (groupName in ref) {
        value = ref[groupName];
        if (value === 1 || value === true) {
          global[groupName] = webdriverio.remote(webdriverConf);
        } else if (_.isNumber(value) && value > 0) {
          global[groupName] = webdriverio.multiremote((function() {
            var i, j, ref1, res, singularName;
            res = {};
            singularName = nounInflector.singularize(groupName);
            for (i = j = 0, ref1 = value; 0 <= ref1 ? j < ref1 : j > ref1; i = 0 <= ref1 ? ++j : --j) {
              res[singularName + i] = webdriverConf;
            }
            return res;
          })());
        } else {
          throw new Error("Wrong number of instances specified for '" + groupName + "' browser group. It must be a number (for multiremote testing) or 'true' (for a single browser)");
        }
      }
      ref1 = webdriverConf.browsers;
      for (groupName in ref1) {
        value = ref1[groupName];
        addCustomCommands(global[groupName]);
      }
      return Bluebird.resolve().then(function() {
        var dbName, ref2;
        dbName = (ref2 = webdriverConf.server.env.MONGO_URL.match(/\/([^\/]*)$/)) != null ? ref2[1] : void 0;
        return shell.exec("mongo " + dbName + " --eval \"db.dropDatabase();\"");
      }).then(function() {
        return typeof customBefore === "function" ? customBefore() : void 0;
      }).then(function() {
        var envStr, key;
        envStr = (function() {
          var ref2, results;
          ref2 = webdriverConf.server.env;
          results = [];
          for (key in ref2) {
            value = ref2[key];
            results.push(key + "=" + value);
          }
          return results;
        })();
        envStr = envStr.join(' ');
        shell.exec(envStr + " " + webdriverConf.server.startCommand, {
          async: true
        });
        return void 0;
      }).then(function() {
        return waitServer(webdriverConf.server.waitServer);
      }).then(function() {
        return Bluebird.mapSeries(Object.keys(webdriverConf.browsers), function(groupName) {
          return global[groupName].init().timeoutsAsyncScript(webdriverConf.waitforTimeout);
        });
      });
    };
  };

}).call(this);
