// Generated by CoffeeScript 1.10.0
(function() {
  module.exports = function(browser) {
    var makeWaitForPageLoad, modelMethod;
    browser.addCommand('shouldExist', function() {
      return this.waitForExist(X.apply(null, arguments)).should.eventually.be["true"];
    });
    browser.addCommand('shouldNotExist', function() {
      return this.waitForExist(X.apply(null, arguments), void 0, true).should.eventually.be["true"];
    });
    browser.addCommand('shouldBeVisible', function() {
      return this.waitForVisible(X.apply(null, arguments)).should.eventually.be["true"];
    });
    browser.addCommand('shouldNotBeVisible', function() {
      return this.waitForVisible(X.apply(null, arguments), void 0, true).should.eventually.be["true"];
    });
    browser.addCommand('shouldExecute', function() {
      return this.execute.apply(this, arguments).then(function(ret) {
        return ret.value;
      }).should.eventually.be["true"];
    });
    browser.addCommand('historyPush', function(url) {
      return this.execute(function(url) {
        delete window._rendered;
        return app.history.push(url);
      }, url).waitUntil(function() {
        return this.execute(function() {
          return window._rendered;
        }).then(function(ret) {
          return ret.value;
        });
      });
    });
    browser.addCommand('historyRefresh', function() {
      return this.execute(function() {
        delete window._rendered;
        return app.history.refresh();
      }).waitUntil(function() {
        return this.execute(function() {
          return window._rendered;
        }).then(function(ret) {
          return ret.value;
        });
      });
    });
    makeWaitForPageLoad = function(fnName) {
      return function() {
        var args, timeout;
        timeout = arguments[arguments.length - 1];
        args = arguments;
        if (typeof timeout === 'number') {
          args = Array.prototype.slice.call(arguments, 1);
        } else {
          timeout = void 0;
        }
        return this.execute(function() {
          return delete window._rendered;
        })[fnName].apply(this, args).waitUntil(function() {
          return this.execute(function() {
            return window._rendered;
          }).then(function(ret) {
            return ret.value;
          });
        }, timeout);
      };
    };
    browser.addCommand('urlAndWait', function() {
      return this.url.apply(this, arguments).waitUntil(function() {
        return this.execute(function() {
          return window._rendered;
        }).then(function(ret) {
          return ret.value;
        });
      });
    });
    browser.addCommand('clickAndWait', makeWaitForPageLoad('click'));
    browser.addCommand('submitFormAndWait', makeWaitForPageLoad('submitForm'));
    modelMethod = function(method, isAsync) {
      return function() {
        return this[isAsync ? 'executeAsync' : 'execute'].apply(this, [
          function(method, isAsync) {
            var args, done, lastArgIndex, res;
            done = void 0;
            lastArgIndex = arguments.length;
            if (isAsync) {
              done = arguments[arguments.length - 1];
              lastArgIndex = arguments.length - 1;
            }
            args = Array.prototype.slice.call(arguments, 2, lastArgIndex);
            return res = app.model[method].apply(app.model, args.concat([
              function() {
                return typeof done === "function" ? done(res) : void 0;
              }
            ]));
          }, method, !!isAsync
        ].concat(Array.prototype.slice.call(arguments))).then(function(ret) {
          return ret.value;
        });
      };
    };
    ['get', 'getCopy', 'getDeepCopy'].forEach(function(method) {
      return browser.addCommand('model' + method.charAt(0).toUpperCase() + method.slice(1), modelMethod(method));
    });
    ['set', 'del', 'setNull', 'setDiff', 'setDiffDeep', 'add', 'increment', 'push', 'unshift', 'insert', 'pop', 'shift', 'remove', 'move', 'stringInsert', 'stringRemove'].forEach(function(method) {
      return browser.addCommand('model' + method.charAt(0).toUpperCase() + method.slice(1), modelMethod(method, true));
    });
    return browser.addCommand('waitForModel', function() {
      return this.executeAsync(function(cb) {
        var _pingId;
        _pingId = '__ping_' + app.model.id();
        return app.model.add('service', {
          id: _pingId
        }, cb);
      }).then(function(ret) {
        return ret.value;
      });
    });
  };

}).call(this);
